=== debian/changelog ===
musescore (2.2.1+dfsg1-4) unstable; urgency=high

  * Cherry-pick another crash bugfix from upstream
  * Also cherry-pick one for a lintian warning
  * Adjust urgency taking previous upload’s waiting time into account

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 26 Apr 2018 17:29:42 +0200

musescore (2.2.1+dfsg1-3) unstable; urgency=medium

  * Upload to unstable again, the qtbase-abi-5-10-0 transition is over
  * Add NEWS documenting the standard soundfont transition
  * Cherry-pick another crash bugfix
  * Loosen musescore-common dependency: most 2.2 packages suffice

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 23 Apr 2018 15:50:22 +0200

musescore (2.2.1+dfsg1-2) experimental; urgency=medium

  * Update Maintainer to d-multimedia@l.d.o
  * Cherry-pick some post-release bugfixes from upstream
  * Bump to Policy 4.1.4 with no changes:
    - our d/rules get-orig-source is already just calling uscan,
      although I prefer to keep it as-is, for packager convenience
  * portmidi is only available on linux-any, cope to fix hurd build
  * Update lintian overrides
  * To avoid disturbing the qtbase-abi-5-10-0 transition,
    upload to experimental

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 12 Apr 2018 22:26:33 +0200

musescore (2.2.1+dfsg1-1) unstable; urgency=low

  * New upstream release (and update upstream release note links)
  * Upload to unstable
  * debian/watch: don’t pick up upstream RCs (as newer than the stable
    release), releases and (our) snapshots only
  * debian/repack: handle API errors better (visible for the packager)
  * debian/rules: pass Freetype include path to cmake explicitly
    (compatibility with older cmake versions, for backports)
  * debian/control: spell more dependencies explicitly, for backports

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 03 Apr 2018 19:51:10 +0200

musescore (2.2~pre20180325+dfsg1-1) experimental; urgency=high

  * Merge musescore (2.1.0+dfsg3-3) unstable; urgency=medium
  * New upstream snapshot
    - Renamed MS_General soundfont to MuseScore_General :|
  * Bump dependency version for fluidr3mono-gm-soundfont accordingly
  * Remove now-unnecessary (or so…) patches

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 25 Mar 2018 23:51:20 +0200

musescore (2.2~pre20180316+dfsg1-1) experimental; urgency=medium

  * Merge musescore (2.1.0+dfsg3-1) unstable; urgency=high
  * Merge musescore (2.1.0+dfsg3-2) unstable; urgency=low:
    + Fix copyright file for fonts, latest licences from upstream
    o (keep patches to fix note collisions)
    + Recommend libmp3lame0 (currently dlopen()ed for MP3 export)
    + Add debian/upstream/metadata as requested by lintian
    - (allow Qt 5.10 for 2.2)
    + Add non-standard field “CLA” to UMEGAYA metadata (boldly)
    + Update patches as submitted upstream, and their merge status
  * Update minimum versions of dependencies
  * Point VCS-* URLs to experimental
  * New upstream snapshot (just shy of the first release candidate)
    - Use upstream-provided hook to disable downloading the soundfont
      from the internet during the build process as we package it
      separately (currently still Fluid (R3) Mono, until MS_General
      will have seen its first stable-ish release to package)
    - Remove applied patches
  * Prefer musescore-general-soundfont for the soundfont dependency
  * Link 2.2 release notes in upstream/changelog file
  * Add patch to correct visual note tracking during playback

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 17 Mar 2018 01:45:22 +0100

musescore (2.2~pre20180302+dfsg1-1) experimental; urgency=high

  * Bump Qt dependency to at least Qt 5.4 for QVector.removeOne()
  * New upstream snapshot of upcoming release (Closes: #802710)
  * Forward patches upstream, update DEP-3 patch headers
  * Fix PCH; build with PCH to speed up package build
  * Make all system-wide soundfonts available to MuseScore
  * Address new lintian concerns
  * Add patches to fix note collisions in playback and MIDI export
  * Allow separately-packaged version of fluidr3mono-gm-soundfont
  * Repack to exclude source-less soundfont from origtgz
  * Fix copyright file for fonts and icons

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 05 Mar 2018 03:38:42 +0100

musescore (2.2~pre20180209+dfsg1-1) experimental; urgency=medium

  [ Thorsten Glaser ]
  * Prepare for packaging a snapshot of the 2.2 upstream branch

  [ Dr. Tobias Quathamer ]
  * New upstream version 2.2~pre20180209+dfsg1
    - Remove 05-desktop-keywords.patch, has been applied upstream
    - Refresh patches
    - Add libportmidi-dev to Build-Depends

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sun, 11 Feb 2018 23:06:04 +0100
